<template>
  <v-card class="py-0 my-0 ">
      <v-card-title v-if="!$store.getters['isMobile']" id="title" :class="[list.class]" >
        <v-layout wrap>
          <v-flex xs12 md12>
            {{ list.title }}
          </v-flex>
          <v-flex xs12 class="subheading">
            Completion: <b>{{getCompletion.toFixed(0) + ' %'}}</b>&nbsp;{{ totalTasksRemaining }}
          </v-flex>
          <v-btn
            absolute
            dark
            fab
            top
            class="hidden-xs-only mt-5"
            right
            color="pink"
            @click="addTask()"
            style="z-index:0"
          >
            <v-icon>add</v-icon>
          </v-btn>
        </v-layout>
      <v-spacer></v-spacer>
      </v-card-title>
      <div
        no-gutters
        v-if="list.tasks && list.tasks.length > 0"
      >
        <div
          v-for="item in list.tasks"
          :key="item.id"
        >
          <Task class="mb-1"
            :task="item"
            v-on:deleteTask="sendEvent('deleteTask', $event)"
            v-on:editTask="sendEvent('editTask', $event)"
            v-on:askAction="sendEvent('askAction', $event)" />
        </div>
      </div>
      <div v-else>
        <v-card>
          <v-card-title class="pl-2 py-0">
            <v-spacer></v-spacer>
            <v-btn color="error black--text" @click="addTask()" type="button">Add task</v-btn>
            <v-spacer></v-spacer>
          </v-card-title>
        </v-card>
      </div>
  </v-card>
</template>

<script>
import TaskService from '@/services/TaskService'
import ErrorService from '@/services/ErrorService'
import Task from '@/components/Task'

export default {
  name: 'Price',
  props: {
    list: {
      type: Object,
      required: true
    }
  },
  components: {
    Task
  },
  data: () => ({
    taskService: new TaskService(),
    errorService: new ErrorService(),
    dialog: false
  }),
  computed: {
    getCompletion: function () {
      if (this.list === null) {
        return 0
      }
      var totalTask = this.list.tasks ? this.list.tasks.length : 0
      if (totalTask === 0) {
        return 0
      }
      var completed = 0
      this.list.tasks.forEach(e => {
        completed += e.checked ? 1 : 0
      })
      return completed / totalTask * 100
    },
    totalTasksRemaining: function () {
      if (this.list === null) {
        return
      }
      var totalTask = this.list.tasks ? this.list.tasks.length : 0
      if (totalTask === 0) {
        return
      }
      var completed = 0
      this.list.tasks.forEach(e => {
        completed += e.checked ? 1 : 0
      })
      return '(' + completed + '/' + totalTask + ')'
    }
  },
  methods: {
    loadTask: function (item) {
      this.$emit('load', item)
    },
    addTask: function () {
      this.$emit('addTaskModal')
    },
    sendEvent: function (name, event) {
      this.$emit(name, event)
    }
  }
}
</script>
